/* :
     .
   MCU: PIC16F690, (CONFIG   :$2007 : 0x0FD4):
   Oscillator > Internal RC No Clock                       ( )
   Watchdog Timer > Off                                (  WDT))
   Power Up Timer > Off                         (   PWRT)
   Master Clear Enable > Disabled ()       (   MCLR)
   Code Protect > Off                                   (  )
   Data EE Read Protect > Off                     ( EEPROM  )
   Brown Out Detect > BOD Enabled, SBOREN Disabled  (   )
   Internal External Switch Over Mode > Enabled
   Monitor Clock Fail-safe > Enabled
           mikroC_PRO_PIC_2009_Build.3.20
           V3 -            
               :   , .   */

//    
   char stroka1 [17] = " 2012  if33   V3"; // 1- 
   char stroka2 [17] = " Dnepropetrovsk "; // 2- 
   char txt1[7];                           //  
   char txt2[7];                           //  
   char txt3[7];                           //   

   sbit LCD_RS at RC7_bit; //  LCD 
   sbit LCD_EN at RB7_bit;
   sbit LCD_D4 at RC6_bit;
   sbit LCD_D5 at RC5_bit;
   sbit LCD_D6 at RC3_bit;
   sbit LCD_D7 at RC4_bit;

   sbit LCD_RS_Direction at TRISC7_bit;
   sbit LCD_EN_Direction at TRISB7_bit;
   sbit LCD_D4_Direction at TRISC6_bit;
   sbit LCD_D5_Direction at TRISC5_bit;
   sbit LCD_D6_Direction at TRISC3_bit;
   sbit LCD_D7_Direction at TRISC4_bit; //   LCD 

   long int U ;               //  - 
   long int I1 ;              //  - 
   unsigned int Uv, Un, Uizm; // ,      
   unsigned int Iv, In, Iizm; // ,      
   unsigned i = 1;            //  

void io_init()         {   // 
   TRISA = 0b00000011;     //  (1)  (0)
   PORTA = 0b00000000;     //   PORTA
   TRISB = 0b00000000;     //    
   PORTB = 0b00000000;     //   PORTC
   TRISC = 0b00000000;     //    
   PORTC = 0b00000000;     //   PORTC
   ANSEL = 0b00000011;     //  AN0, AN1   
   ANSELH = 0b00000000;    //     I/O
   OPTION_REG = 0b10000000;//  
   OSCCON = 0b01110100;    //   8 
   OSCTUNE = 0b00000111;   //    
   VRCON = 0b10001000;     // VRCON -    = Udd/2
   INTCON = 0b00000000; }  //   

void display (void) {
   Lcd_Out(1,1, stroka1);     //    1- 
   Lcd_Out(2,1, stroka2); }   //    2- 

void izm_U(void) {    //     
   Uizm = 0;  U = 0; Uv = 0; Un = 1024;
   Iizm = 0; I1 = 0; Iv = 0; In = 1024;
   for (i = 0; i < 2000; i++) {//      180 
   ADCON0 = 0b00000101;        // VREF, in AN1
   Uizm = Adc_Read(1);         //    AN1
   ADCON0 = 0b00000001;        // VREF, in AN0
   Iizm = Adc_Read(0);         //    AN0
   if (Uizm < Un) Un = Uizm;   //   
   if (Uizm > Uv) Uv = Uizm;   //   
   if (Iizm < In) In = Iizm;   //   
   if (Iizm > Iv) Iv = Iizm;}  //   
   U = Uv - Un;                //  4U
   I1 =Iv - In;}               //  I1
   
   void CustomChar()  //    ""
    {char character[] = {\
    0,0,15,9,9,9,9,0,\
    0,0,6,9,9,9,6,0,\
    0,0,15,9,9,9,17,0,\
    0,0,9,9,15,9,9,0};
    char i; LCD_Cmd(64 );
    for (i = 0; i<32; i++) LCD_Chr_Cp(character[i]); }

void main(void){
  io_init();
  Lcd_Init();                 //  LCD
  Lcd_Cmd(_LCD_CLEAR);        //  
  Lcd_Cmd(_LCD_CURSOR_OFF);   //  
  display ();               // 
  Delay_ms(200);
  CustomChar();

  while(1) {                  //  
  izm_U();
  //        
   WordToStr(U / 4, txt1);    //  
   stroka1[0] = 'U'; stroka1[1] = '='; stroka1[2] = txt1[2];
   stroka1[3] = txt1[3]; stroka1[4] = txt1[4]; stroka1[5] = 'v';
   stroka1[6] = ' '; stroka1[7] = ' '; stroka1[8] = 'I'; stroka1[9] = '=';

   WordToStr(I1, txt2);       //  
   stroka1[10] = txt2[1];
   if (txt2[2] == ' ') stroka1[11] = '0'; else stroka1[11] = txt2[2];
   stroka1[12] = '.';
   if (txt2[3] == ' ') stroka1[13] = '0'; else stroka1[13] = txt2[3];
   stroka1[14] = txt2[4]; stroka1[15] = 'a';

   WordToStr((U * I1 / 400), txt3); //  
    stroka2[0] = ' ';
    stroka2[1] = ' ';
    stroka2[2] = 'S';
    stroka2[3] = 0x08;  // 
    stroka2[4] = 0x09;  // 
    stroka2[5] = 0x0A;  // 
    stroka2[6] = 0x0B;  // 
    stroka2[7] = '=';
    stroka2[8] = txt3[1];
    stroka2[9] = txt3[2];
    stroka2[10] = txt3[3];
    stroka2[11] = txt3[4];
    stroka2[12] = 'v';
    stroka2[13] = 'a';
    stroka2[14] = ' ';
    stroka2[15] = ' ';

  display ();
  Delay_ms(20);
  }
}
